//debug mode (sassert) will be turned off when defined
//#define NDEBUG

#include <DSOL.hpp>


//generated with grit
#include "pacman.h"
const uint                  pacmanOAMIndex      = 0;//index 0 of the main oam/engine
const SpriteSize            pacmanSize          = SpriteSize_8x8;
const SpriteColorFormat     pacmanColorFormat   = SpriteColorFormat_16Color;


//generated with grit
#include "ghost.h"
const uint                  ghostOAMIndex       = 0;//index 0 of the sub oam/engine
const SpriteSize            ghostSize           = SpriteSize_8x8;
const SpriteColorFormat     ghostColorFormat    = SpriteColorFormat_16Color;



int main()
{
	using namespace DSOL;

	init2d();

    //========================
    //first constructor
	//========================
	Sprites::Sprite pacman(pacmanOAMIndex,
                pacmanTiles, pacmanTilesLen, pacmanPal, pacmanPalLen,//generated with grit
                pacmanSize, pacmanColorFormat,
                true,               //main oam (defaults to top screen)
                false);             //no affine matrix (rotating, scaling, ect)

    pacman.setPosition(20, 20);
    pacman.update();


    //========================
    //second constructor
    //========================

    //TODO: add some checks to see if everything is correctly allocated

    //allocating vram and writing to is.
    u16* gfx = oamAllocateGfx(&oamSub, ghostSize, ghostColorFormat);
    Sprites::copyGfxData(ghostTiles, gfx, ghostTilesLen / 2);//ghost has 2 frames

    //reserving a palette and writing to it.
    uint ghostPaletteIndex = Sprites::Palette::reserveEmptyPalette(false, true);//sub oam and 16 colors
    Sprites::Palette::writeToPalette(false, true, ghostPaletteIndex, ghostPal, ghostPalLen);

    //creating the sprite
    Sprites::Sprite ghost(ghostOAMIndex, ghostSize, ghostColorFormat, gfx, ghostPaletteIndex,
                    false, NULL);//sub oam and no affine matrix (rotating, scaling, ect)
    ghost.setPosition(20, 20).update();//chaining commands, so we don't have to type as much (can't chain after update)




    //update everything and loop forever
    sleepForever();

    //freeing stuff we have used for the second constructor
    Sprites::Palette::freePalette(false, true, ghostPaletteIndex); //sub oam and 16 colors
    oamFreeGfx(&oamSub, gfx);

	return 0;
}
