#ifndef MAIN_HPP_INC
#define MAIN_HPP_INC

/**
    @file DSOL.hpp
    @brief the masterfile that includes everything.

    include this file in your project.
*/


/**
    @mainpage DSOL documentation.

    @section intro
    DSOL is a Object Orientated library for the nds.


*/


//making sure that a c++ compiler is used
#ifndef __cplusplus
#error not using a c++ compiler, please change the file extention to *.cpp and/or use a c++ compiler
#endif

//gives a warning if debug mode is turned off
#ifdef NDEBUG
#warning debug mode/assertions are turned off
#endif


//already included with libnds (nds.h)
//#include <sassert.h>

//including libnds
#include <nds.h>

//making sure that NULL contains '0', no more, no less
//after the libnds include, so it doesn't cause problems with libnds
#ifdef NULL
#undef NULL
#endif
#define NULL 0





//==========library includes==========
//definitons and functions
#include "standardDefines.hpp"
#include "MemoryFunctions.hpp"
#include "Random.hpp"
#include "initialise.hpp"


//interfases
#include "IUpdater.hpp"


//general purpose utilities
#include "LiteVector.hpp"
#include "BooleanArray.hpp"



//Sprite namespace
#include "Sprite.hpp"
#include "AffineMatrix.hpp"
#include "Palette.hpp"


#endif // MAIN_HPP_INC
