#ifndef IUPDATER_HPP_INC
#define IUPDATER_HPP_INC

/** @file IUpdater.hpp
    @brief this file contains a interfase class with a single pure virtual function update().
*/

#include "standardDefines.hpp"

namespace DSOL
{

/** @class IUpdater
    @brief an updater interfase that makes sure that every class implementing this has an update() fucntion.
*/
//lets hope doxigen works with the interfase defines
Interface(IUpdater)

    /**
        @brief a pure virtual update function.

        you can call this function on every instance of a class implementing IUpdater.
        the instance should then update everything he wants.
    */
    virtual void update() = 0;

endInterface


}//end namespace DSOL

#endif // IUPDATER_HPP_INC
