#ifndef INITIALISE_HPP_INC
#define INITIALISE_HPP_INC

/**
    @file initialise.hpp
    @brief some general functions about initialising and updating the DS.
*/

#include "Random.hpp"

namespace DSOL
{

/**
    @brief a quick init function for 2d mode.
*/
void init2d();


/**
    @brief a quick vblank function that updates everything.
*/
void waitForVBlank();


/**
    @brief a function to wait a certain amount of time.

    this function will wait at least 2 vblanks before continuing.

    @param vblanks the number of vblanks to wait. note that there are about 60 vblanks in a second.
*/
void sleep(uint vblanks);


/**
    @brief puts the DS into a powersaving endless loop.
*/
void sleepForever();


}//end namespace DSOL

#endif // INITIALISE_HPP_INC
