#ifndef STANDARDDEFINES_HPP_INC
#define STANDARDDEFINES_HPP_INC

/**
    @file standardDefines.hpp
    @brief some commenly used values and defines.
*/

namespace DSOL
{

/** @brief a constant value for specifying the dma priority */
static const int DMA_PRIORITY = 3;


/**
    @brief a constant for specifying to call the 'reconstruct' constructor, instead of the copy constructor.
    look at one of the 'reconstruct' constructors for more information, like SimpleVectors 'reconstruct' constructor
    (they are useally private, and thus not in the document).
*/
static const uint RECONSTRUCT = 0;



/**
    @brief a define for creating an interfase

    @see <a href>http://www.codeguru.com/cpp/cpp/cpp_mfc/oop/article.php/c9989</a>

    @param name the name of the interfase
*/
#define Interface(name) class name { \
          public: \
          virtual ~name(){}

/**
    @brief a define to create a subInterfase (an interfase that inherits from an interfase)

    @param name the name of the subInterfase
    @param base the interfase to inherit from
*/
#define subInterface(name, base) class name : public base { \
           public: \
           virtual ~name(){}

/** @brief a define to end the interfase with */
#define endInterface };

/** @brief a define to use an interfase */
#define implements public


}//end namespace DSOL

#endif // STANDARDDEFINES_HPP_INC
