//including libnds
#include <nds.h>

#include "AffineMatrix.hpp"


namespace DSOL
{

namespace Sprites
{

BooleanArray AffineMatrix::mainAffineSprites(NUMBER_OF_AFFINE_MATRIXES);
BooleanArray AffineMatrix::subAffineSprites(NUMBER_OF_AFFINE_MATRIXES);


/*static*/ uint AffineMatrix::reserveEmptyAffineMatrix(const bool mainOAM /*= true*/)
{
    register BooleanArray& tempPalette = (mainOAM ? mainAffineSprites : subAffineSprites);

    for(uint i = 0; i < NUMBER_OF_AFFINE_MATRIXES; i++)
    {
        if(tempPalette.get(i) == false)
        {
            tempPalette.set(i, true);
            return i;
        }
    }

    sassert(false, "error: no empty affine matrixes left");

    //we have to return something
    return NUMBER_OF_AFFINE_MATRIXES;
}




AffineMatrix& AffineMatrix::setAngleScale(const int angle /*= 0*/, const int scaleX /*= (1 << 8)*/, const int scaleY /*= (1 << 8)*/)
{
    //sinLerp and cosLerp returns .12 fixed point, so we need to shift the result back by 12
    register const int ss = sinLerp(angle);
    hdy =-ss*scaleX>>12;
    vdx = ss*scaleY>>12;

    register const int cc = cosLerp(angle);
    hdx = cc*scaleX>>12;
    vdy = cc*scaleY>>12;

    return *this;
}


}// end namespace Sprites


}//end namespace DSOL
