//including libnds
#include <nds.h>


#include "initialise.hpp"


namespace DSOL
{

void init2d()
{
    powerOn(POWER_ALL_2D);

	//we dont have to enable backgrounds and sprites, because libnds does that for us
	videoSetMode(MODE_0_2D);//TODO: 'update' after working with libnds background api
    videoSetModeSub(MODE_0_2D);//TODO: 'update' after working with libnds background api

	vramSetBankA(VRAM_A_MAIN_SPRITE);
	vramSetBankB(VRAM_B_MAIN_BG);
    vramSetBankC(VRAM_C_SUB_BG);
    vramSetBankD(VRAM_D_SUB_SPRITE);

    //not decided what this should be used for
    //vramSetBankE();

    vramSetBankF(VRAM_F_BG_EXT_PALETTE);//main background palettes
    vramSetBankG(VRAM_G_SPRITE_EXT_PALETTE);//main sprites palettes
    vramSetBankH(VRAM_H_SUB_BG_EXT_PALETTE);//sub background palettes
    vramSetBankI(VRAM_I_SUB_SPRITE_EXT_PALETTE);//sub sprites palettes


	//allow both tiled and bitmap sprites, and using extended palettes
	oamInit(&oamMain, SpriteMapping_Bmp_1D_128, true);
	oamInit(&oamSub, SpriteMapping_Bmp_1D_128, true);

	seedRandDefault();
	defaultExceptionHandler();
}


void waitForVBlank()
{
    swiWaitForVBlank();
    oamUpdate(&oamMain);
    oamUpdate(&oamSub);
}



void sleep(uint vblanks)
{
    //updates everything (put sprites on the screen)
    waitForVBlank();

    for(uint i = 2; i < vblanks; ++i)
    {
        swiWaitForVBlank();
    }

    //updates everything (update input, if that is supported)
    waitForVBlank();
}



void sleepForever()
{
    //updates everything (put sprites on the screen)
    waitForVBlank();

    while(true)
    {
        swiWaitForVBlank();
    }
}

}//end namespace DSOL
